com.corticon.eclipse.studio.drivers.core

## Interface IDatabaseDefinition

-     public interface IDatabaseDefinition

  Title: IDatabaseDefinition

  Description: An interface for the database definition API

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `areCatalogsSupported(java.lang.String astrId)` Retrieve the flag for the catalogs support.
    `boolean` | `areTransactionsToBeIgnored(java.lang.String astrId)` Retrieve the flag which indicates whether transactions are to be ignored.
    `java.lang.String` | `findDatabaseId(java.lang.String astrDatabaseServerName)` Retrieve the Database Server ID using the database server user-friendly name (reverse lookup).
    `java.util.List<java.lang.String>` | `getAuthenticationTypes(java.lang.String astrId)` Retrieve the list of authentication type strings
    `java.util.Collection<java.lang.String>` | `getDatabaseIDs()` Retrieve a collection of unique database definition identifiers (IDs).
    `java.lang.String` | `getDatabaseUrlTemplate(java.lang.String astrId)` Retrieve a template of the database JDBC URL.
    `java.lang.String` | `getDefaultNumericIdentityStrategy(java.lang.String astrId)` Retrieve the default numeric identity strategy type.
    `java.lang.String` | `getDefaultStringIdentityStrategy(java.lang.String astrId)` Retrieve the default string identity strategy.
    `java.lang.String` | `getDialect(java.lang.String astrId)` Retrieve the Hibernate Dialect class name be used with a particular database.
    `java.lang.String` | `getDriverClassName(java.lang.String astrId)` Retrieve the JDBC driver class name associated with a particular database.
    `java.lang.String` | `getGeneratedKeyStrategy(java.lang.String astrId)` Retrieve the GenerateKey Strategy to be used by the driver.
    `java.util.Collection<java.lang.String>` | `getHDPDatabaseNames(boolean abIncludeDeprecated)` Retrieve a collection of user-friendly database names for the Vocabulary Database Access tab.
    `java.util.Collection<java.lang.String>` | `getNumericIdentityStrategies(java.lang.String astrId)` Retrieve the list of numeric identity strategies
    `java.util.Map<java.lang.String,java.lang.String>` | `getReserveWordReplacements(java.lang.String astrId)` Returns a map of reserve word replacements associated with the supplied database id.
    `java.util.Collection<java.lang.String>` | `getStringIdentityStrategies(java.lang.String astrId)` Retrieve the list of string identity strategies
    `java.util.List<java.lang.String>` | `getSupportedSqlTypes(java.lang.String astrId, java.lang.String astrCorticonDataTypeName)` Determine whether a given Corticon Data Type can be mapped to a given SQL type within the specified database.
    `java.lang.String` | `getUserFriendlyName(java.lang.String astrId)` Retrieve the user-friendly name of a particular database.
    `java.util.Collection<java.lang.String>` | `getUserFriendlyNames()` Retrieve a collection of user-friendly database names for the Vocabulary Database Access tab.
    `java.util.Collection<java.lang.String>` | `getUserFriendlyNames(boolean abIncludeDeprecated)` Retrieve a collection of user-friendly database names for the Vocabulary Database Access tab.
    `java.lang.String` | `getValidationQuery(java.lang.String astrId)` Retrieve a query used to validate a database connection.
    `boolean` | `hasMandatoryValueStrategy(java.lang.String astrId)` Retrieve the flag for the mandatory value strategy.
    `boolean` | `isDeprecated(java.lang.String astrId)` Retrieve the depreciated flag.
    `boolean` | `isGetGeneratedKeysSupported(java.lang.String astrId)` Retrieve the flag for the getGeneratedKeys support.
    `boolean` | `isReadOnlyModeSupported(java.lang.String astrId)` Retrieve the flag for the read only mode support.
    `boolean` | `isSchemaCreationSupported(java.lang.String astrId)` Retrieve the flag for the database schema creation support.
    `boolean` | `isSupportedSqlTypeMapping(java.lang.String astrId, java.lang.String astrCorticonDataTypeName, java.lang.String astrSqlTypeName)` Determine whether a given Corticon Data Type can be mapped to a given SQL type within the specified database.
    `boolean` | `isVisible(java.lang.String astrId)` Retrieve the visible flag.
    `java.lang.String` | `processMultiPartID(java.lang.String astrID, java.lang.String astrMethod)` Process a multi-value ID and return the ID for the specified method

- - ### Method Detail

    - #### findDatabaseId

          java.lang.String findDatabaseId(java.lang.String astrDatabaseServerName)

      Retrieve the Database Server ID using the database server user-friendly name (reverse lookup).
      Parameters:
        `astrDatabaseServerName` - Localized database server name.
      Returns:
        Database Server ID or `null`.``

    - #### getDatabaseIDs

          java.util.Collection<java.lang.String> getDatabaseIDs()

      Retrieve a collection of unique database definition identifiers (IDs).
      Returns:
        The collection of database definition identifiers.

    - #### getUserFriendlyNames

          java.util.Collection<java.lang.String> getUserFriendlyNames()

      Retrieve a collection of user-friendly database names for the Vocabulary Database Access tab. This will not include depreciated databases.
      Returns:
        The collection of user-friendly database names.

    - #### getUserFriendlyNames

          java.util.Collection<java.lang.String> getUserFriendlyNames(boolean abIncludeDeprecated)

      Retrieve a collection of user-friendly database names for the Vocabulary Database Access tab. Will not include definitions without a driver class.
      Parameters:
        `abIncludeDeprecated` - flag to indicate if depreciated databases should be included in the list.
      Returns:
        The collection of user-friendly database names.

    - #### getHDPDatabaseNames

          java.util.Collection<java.lang.String> getHDPDatabaseNames(boolean abIncludeDeprecated)

      Retrieve a collection of user-friendly database names for the Vocabulary Database Access tab. Will not include the HDP or ARC definitions. Will include definitions without a driver class.
      Parameters:
        `abIncludeDeprecated` - flag to indicate if depreciated databases should be included in the list.
      Returns:
        The collection of user-friendly database names.

    - #### getUserFriendlyName

          java.lang.String getUserFriendlyName(java.lang.String astrId)

      Retrieve the user-friendly name of a particular database.
      Parameters:
        `astrId` - database definition identifier whose user friendly name should be returned.
      Returns:
        User friendly name.

    - #### processMultiPartID

          java.lang.String processMultiPartID(java.lang.String astrID,
                                              java.lang.String astrMethod)

      Process a multi-value ID and return the ID for the specified method
      Parameters:
        `astrId` - database definition identifier
        `astrMethod` - the method the ID will be used for
      Returns:
        a single value driver ID

    - #### getDriverClassName

          java.lang.String getDriverClassName(java.lang.String astrId)

      Retrieve the JDBC driver class name associated with a particular database.
      Parameters:
        `astrId` - database definition identifier whose JDBC driver class name should be returned;
      Returns:
        Driver class name.

    - #### getDialect

          java.lang.String getDialect(java.lang.String astrId)

      Retrieve the Hibernate Dialect class name be used with a particular database.
      Parameters:
        `astrId` - database definition identifier whose Hibernate Dialect class name should be returned;
      Returns:
        Hibernate dialect class.

    - #### getDatabaseUrlTemplate

          java.lang.String getDatabaseUrlTemplate(java.lang.String astrId)

      Retrieve a template of the database JDBC URL.
      Parameters:
        `astrId` - database definition identifier whose database URL template should be returned;
      Returns:
        Database URL template.

    - #### getValidationQuery

          java.lang.String getValidationQuery(java.lang.String astrId)

      Retrieve a query used to validate a database connection. The query must return a single row with return value “1”.
      Parameters:
        `astrId` - database definition identifier whose validation query should be returned;
      Returns:
        Validation query.

    - #### isSupportedSqlTypeMapping

          boolean isSupportedSqlTypeMapping(java.lang.String astrId,
                                            java.lang.String astrCorticonDataTypeName,
                                            java.lang.String astrSqlTypeName)

      Determine whether a given Corticon Data Type can be mapped to a given SQL type within the specified database.
      Parameters:
        `astrId` - Database definition ID.
        `astrCorticonDataTypeName` - Corticon Data Type name (e.g., Decimal).
        `astrSqlTypeName` - SQL type name (e.g., DECIMAL).
      Returns:
        `true` if the mapping is valid.

    - #### getSupportedSqlTypes

          java.util.List<java.lang.String> getSupportedSqlTypes(java.lang.String astrId,
                                                                java.lang.String astrCorticonDataTypeName)

      Determine whether a given Corticon Data Type can be mapped to a given SQL type within the specified database.
      Parameters:
        `astrId` - Database definition ID.
        `astrCorticonDataTypeName` - Corticon Data Type name (e.g., Decimal).
      Returns:
        List of supported SQL types.

    - #### getDefaultStringIdentityStrategy

          java.lang.String getDefaultStringIdentityStrategy(java.lang.String astrId)

      Retrieve the default string identity strategy.
      Parameters:
        `astrId` - database definition identifier whose validation query should be returned;
      Returns:
        Identity strategy name or `null` if not defined.

    - #### getDefaultNumericIdentityStrategy

          java.lang.String getDefaultNumericIdentityStrategy(java.lang.String astrId)

      Retrieve the default numeric identity strategy type.
      Parameters:
        `astrId` - database definition identifier whose validation query should be returned;
      Returns:
        Identity strategy name or `null` if not defined.

    - #### isSchemaCreationSupported

          boolean isSchemaCreationSupported(java.lang.String astrId)

      Retrieve the flag for the database schema creation support.
      Parameters:
        `astrId` - database definition identifier whose validation query should be returned;
      Returns:
        `true` if database schema creation is supported.

    - #### areTransactionsToBeIgnored

          boolean areTransactionsToBeIgnored(java.lang.String astrId)

      Retrieve the flag which indicates whether transactions are to be ignored.
      Parameters:
        `astrId` - database definition identifier whose validation query should be returned;
      Returns:
        `true` if transactions should be ignored.

    - #### isReadOnlyModeSupported

          boolean isReadOnlyModeSupported(java.lang.String astrId)

      Retrieve the flag for the read only mode support.
      Parameters:
        `astrId` - database definition identifier whose validation query should be returned;
      Returns:
        `true` if read only mode is supported.

    - #### isGetGeneratedKeysSupported

          boolean isGetGeneratedKeysSupported(java.lang.String astrId)

      Retrieve the flag for the getGeneratedKeys support.
      Parameters:
        `astrId` - database definition identifier whose validation query should be returned;
      Returns:
        `true` if getGeneratedKeys is supported.

    - #### hasMandatoryValueStrategy

          boolean hasMandatoryValueStrategy(java.lang.String astrId)

      Retrieve the flag for the mandatory value strategy.
      Parameters:
        `astrId` - database definition identifier whose validation query should be returned;
      Returns:
        `true` if the value strategy is mandatory.

    - #### areCatalogsSupported

          boolean areCatalogsSupported(java.lang.String astrId)

      Retrieve the flag for the catalogs support.
      Parameters:
        `astrId` - database definition identifier whose validation query should be returned;
      Returns:
        `true` if catalogs are supported.

    - #### getNumericIdentityStrategies

          java.util.Collection<java.lang.String> getNumericIdentityStrategies(java.lang.String astrId)

      Retrieve the list of numeric identity strategies
      Parameters:
        `astrId` - Database definition ID.
      Returns:
        Set of numeric identity strategies.

    - #### getStringIdentityStrategies

          java.util.Collection<java.lang.String> getStringIdentityStrategies(java.lang.String astrId)

      Retrieve the list of string identity strategies
      Parameters:
        `astrId` - Database definition ID.
      Returns:
        Set of string identity strategies.

    - #### isDeprecated

          boolean isDeprecated(java.lang.String astrId)

      Retrieve the depreciated flag.
      Parameters:
        `astrId` - database definition identifier whose depreciated flag should be returned;
      Returns:
        `true` if the database is depreciated.

    - #### isVisible

          boolean isVisible(java.lang.String astrId)

      Retrieve the visible flag.
      Parameters:
        `astrId` - database definition identifier whose visible flag should be returned;
      Returns:
        `true` if the database is visible.

    - #### getAuthenticationTypes

          java.util.List<java.lang.String> getAuthenticationTypes(java.lang.String astrId)

      Retrieve the list of authentication type strings
      Parameters:
        `astrId` - Database definition ID.
      Returns:
        Set of authentication type strings.

    - #### getReserveWordReplacements

          java.util.Map<java.lang.String,java.lang.String> getReserveWordReplacements(java.lang.String astrId)

      Returns a map of reserve word replacements associated with the supplied database id.
      Parameters:
        `astrId` - Database definition ID.
      Returns:
        Map that contains the original values (keys) and their replacements (value)

    - #### getGeneratedKeyStrategy

          java.lang.String getGeneratedKeyStrategy(java.lang.String astrId)

      Retrieve the GenerateKey Strategy to be used by the driver.
      Parameters:
        `astrId` - Database definition ID.
      Returns:
        strategy String

Copyright © 2005-2023 Progress Software Corporation and/or its subsidiaries and affiliates. All rights reserved.